/*
 * $Id: eek.h 19 2004-02-22 15:03:15Z tilman $
 *
 * Copyright (C) 2004 Eek project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __EEK_H
#define __EEK_H

#include <limits.h>

typedef enum {
	EEK_THEME_TYPE_NONE,
	EEK_THEME_TYPE_KJOFOL,
	EEK_THEME_TYPE_NUM
} EekThemeType;

struct _Eek;

typedef bool (*EekConvertFunc)(struct _Eek *e);

typedef struct _Eek {
	EekThemeType theme_type;
	char name[64];

	char source[PATH_MAX + 1];
	char source_dir[PATH_MAX + 1];
	char dest[PATH_MAX + 1];

	EekConvertFunc convert;
} Eek;

Eek *eek_new ();
void eek_free (Eek *e);

void eek_theme_type_set (Eek *e, char *type);

void eek_source_set (Eek *e, const char *source);
const char *eek_source_get (Eek *e);
const char *eek_source_dir_get (Eek *e);

void eek_dest_set (Eek *e, const char *dest);
const char *eek_dest_get (Eek *e);

void eek_name_set (Eek *e, const char *name);
const char *eek_name_get (Eek *e);

bool eek_run (Eek *e);

#endif
