/*
 * $Id: kjofol_theme.h 9 2004-02-15 13:07:23Z tilman $
 *
 * Copyright (C) 2004 Eek project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __KJOFOL_PARSE_H
#define __KJOFOL_PARSE_H

#include "list.h"

typedef enum {
	KJ_THEME_ELEMENT_TYPE_NONE,
	KJ_THEME_ELEMENT_TYPE_IMAGE,
	KJ_THEME_ELEMENT_TYPE_BUTTON,
	KJ_THEME_ELEMENT_TYPE_WINDOW
} KjThemeElementType;

typedef enum {
	KJ_THEME_ELEMENT_GROUP_NONE,
	KJ_THEME_ELEMENT_GROUP_MAIN,
	KJ_THEME_ELEMENT_GROUP_PLAYLIST,
	KJ_THEME_ELEMENT_GROUP_NUM
} KjThemeElementGroup;

typedef struct {
	char path[64];
	int x, y, w, h;
} KjButton;

typedef struct {
	char path[64];
	int w, h;
} KjImage;

typedef struct {
	int x, y, w, h;
} KjWindow;

typedef struct {
	KjThemeElementType type;
	KjThemeElementGroup group;
	char id[64];
	int id_len;

	union {
		KjImage im;
		KjButton but;
		KjWindow win;
	} data;
} KjThemeElement;

typedef struct {
	Eek *e;
	List *elements;
} KjTheme;

typedef enum {
	KJ_THEME_ELEMENT_STATE_DEFAULT,
	KJ_THEME_ELEMENT_STATE_PRESSED,
	KJ_THEME_ELEMENT_STATE_NUM
} KjThemeElementState;

extern const char *kjofol_theme_element_state[KJ_THEME_ELEMENT_STATE_NUM];
extern const char *kjofol_theme_element_group[KJ_THEME_ELEMENT_GROUP_NUM];

KjTheme *kjofol_theme_new (Eek *e);
void kjofol_theme_free (KjTheme *k);

bool kjofol_theme_element_add (KjTheme *k, KjThemeElementType type,
                               KjThemeElementGroup group, char *id);

KjThemeElement *kjofol_theme_element_find (KjTheme *k,
                                           KjThemeElementType type,
                                           KjThemeElementGroup group,
                                           char *id);

bool kjofol_theme_read (KjTheme *k);

#endif
