/*
 * $Id: list.c 2 2004-02-14 21:59:28Z tilman $
 *
 * Copyright (C) 2004 Eek project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdlib.h>
#include <assert.h>

#include "list.h"

List *list_prepend (List *list, void *data)
{
	List *item;

	assert (data);

	if (!(item = malloc (sizeof (List))))
		return list;

	item->data = data;
	item->next = list;
	item->prev = NULL;

	if (list)
		list->prev = item;

	return item;
}

List *list_find (List *list, void *data)
{
	List *l;

	assert (list);
	assert (data);

	for (l = list; l; l = l->next)
		if (l->data == data)
			return l;

	return NULL;
}

List *list_remove (List *list, void *data)
{
	List *l, *p, *n;

	assert (list);
	assert (data);

	if (!(l = list_find (list, data)))
		return list;

	p = l->prev;
	n = l->next;

	if (p)
		p->next = n;
	else
		list = n;

	if (n)
		n->prev = p;

	free (l);

	return list;
}

